# frozen_string_literal: true

require 'nokogiri'
require 'open-uri'
require 'httparty'

AUTH_TOKEN = '43a345ee370fdfafc836b3534b4311a3a8ee45df'

class GemStatictic
  attr_reader :gem_name
  def initialize(gem_name)
    @gem_name = gem_name[0]
  end

  def create_stat
    parse = {
      gem_name: gem_name,
      used_by: find_used_by,
      watch_by: find_wath_by,
      stars: find_stars,
      forks: find_forks,
      contributors: find_contributors,
      open_issues: find_issues
    }
    p parse
  end

  private

  # def gem?
  #   url = "https://rubygems.org/api/v1/gems/#{gem_name}.json"
  #   HTTParty.get(url).parsed_response['name'].nil?
  # end

  def find_repo
    # raise StandardError if gem?
    url = "https://#{AUTH_TOKEN}@api.github.com/search/repositories?q=#{gem_name}&per_page=1"
    HTTParty.get(url).parsed_response['items'][0]['html_url'].to_s
    # rescue StandardError => e
    #   puts "ERR: [#{gem_name}] gem could not be found."
  end

  def downgload_html
    @downgload_html ||= Nokogiri.HTML(::Kernel.open(find_repo))
  end

  def downgload_used_html
    @downgload_used_html ||= Nokogiri.HTML(::Kernel.open("#{find_repo}/network/dependents"))
  end

  def find_used_by
    downgload_used_html.css('.btn-link').css('.selected').text.tr('^0-9', '').to_i
  end

  def find_wath_by
    downgload_html.css("a[class='social-count']")[0].text.tr('^0-9', '').to_i
  end

  def find_stars
    downgload_html.css("a[class='social-count js-social-count']").text.tr('^0-9', '').to_i
  end

  def find_forks
    downgload_html.css("a[class='social-count']")[1].text.tr('^0-9', '').to_i
  end

  def find_contributors
    downgload_html.css("span[class='num text-emphasized']")[-1].text.tr('^0-9', '').to_i
  end

  def find_issues
    downgload_html.css("span[class='Counter']")[0].text.tr('^0-9', '').to_i
  end
end
n = GemStatictic.new(ARGV).create_stat
